unit ResizerReg;

interface

uses
  CustomRP, NoBDERP, Resizer,
{$IFDEF WIN32}
  Windows, ComCtrls,
{$ELSE}
  WinTypes, WinProcs,
{$ENDIF}
  Forms, Messages, SysUtils, Classes, Controls, ExtCtrls, Dialogs,
  TypInfo, Grids, DesignIntf, DesignEditors;

type
  TWarningListForm = class(TForm)
    Grid: TStringGrid;
    procedure FormActivate(Sender: TObject);
  private
  public
    Value: TStringList;
  end;

  TResizerPanelEditor = class(TComponentEditor)
  public
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;


  procedure Register;

  
var
  WarningListForm: TWarningListForm;

implementation

{$R *.DFM}

procedure Register;
begin
  RegisterComponents('Additional', [TResizerPanel]);
  RegisterComponents('Additional', [TNoBDEResizerPanel]);
  RegisterComponentEditor(TCustomResizerPanel, TResizerPanelEditor);
end;

function TResizerPanelEditor.GetVerb(Index: Integer): string;
begin
  if Index = 0 then
    Result := 'Warnings'
  else
    Result := inherited GetVerb(Index);
end;

function TResizerPanelEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

procedure TResizerPanelEditor.ExecuteVerb(Index: Integer);
var
   Dialog: TWarningListForm;
begin
  if Index = 0 then
  begin
    Dialog := TWarningListForm.Create( nil );
    try
      Dialog.Value := TCustomResizerPanel(Component).Warnings;
      Dialog.ShowModal;
    finally
      Dialog.Free;
    end;
  end;
end;



procedure TWarningListForm.FormActivate(Sender: TObject);
var
  Cnt: Integer;
begin
  if (Assigned(Value) and (Value.Count > 0)) then
  begin
    Grid.RowCount := Value.Count+1;

    for Cnt := 0 to Value.Count-1 do
    begin
      Grid.Cells[0, Cnt+1] := TControl(Value.Objects[Cnt]).Name;
      Grid.Cells[1, Cnt+1] := Value.Strings[Cnt];
    end;
  end
  else
  begin
    Grid.RowCount := 2;
    Grid.Cells[0,1] := '';
    Grid.Cells[1,1] := '';
  end;

  Grid.Cells[0,0] := 'Control Name';
  Grid.Cells[1,0] := 'Warning Message';
end;

function GetPropertyInfo( ClassInfo: Pointer; PropName: String ): Pointer;
begin
  Result := GetPropInfo( ClassInfo, PropName );
  if (Result = nil) then
    raise Exception.Create('No ' + PropName + ' property');
end;

end.
